# Changelog

[npm history][1]

[1]: https://www.npmjs.com/package/@google-cloud/projectify?activeTab=versions
## v0.3.2

### Bug fixes
- fix: do not replace projectId on stream objects ([#53](https://github.com/googleapis/nodejs-projectify/pull/53))

### Dependencies
- chore(deps): update dependency gts to ^0.9.0 ([#52](https://github.com/googleapis/nodejs-projectify/pull/52))

### Internal / Testing Changes
- chore: update eslintignore config ([#51](https://github.com/googleapis/nodejs-projectify/pull/51))
- chore: use latest npm on Windows ([#50](https://github.com/googleapis/nodejs-projectify/pull/50))
- chore: update CircleCI config ([#49](https://github.com/googleapis/nodejs-projectify/pull/49))
- chore: include build in eslintignore ([#46](https://github.com/googleapis/nodejs-projectify/pull/46))

## v0.3.1

### Implementation Changes
- fix: replaceProjectId should not fail when passed a Buffer ([#43](https://github.com/googleapis/nodejs-projectify/pull/43))

### Dependencies
- chore(deps): update dependency nyc to v13 ([#13](https://github.com/googleapis/nodejs-projectify/pull/13))
- chore(deps): lock file maintenance ([#11](https://github.com/googleapis/nodejs-projectify/pull/11))
- chore(deps): lock file maintenance ([#8](https://github.com/googleapis/nodejs-projectify/pull/8))
- chore(deps): update dependency typescript to v3 ([#7](https://github.com/googleapis/nodejs-projectify/pull/7))
- chore(deps): update dependency gts to ^0.8.0 ([#2](https://github.com/googleapis/nodejs-projectify/pull/2))
- chore(deps): lock file maintenance ([#4](https://github.com/googleapis/nodejs-projectify/pull/4))
- chore(deps): lock file maintenance ([#3](https://github.com/googleapis/nodejs-projectify/pull/3))

### Internal / Testing Changes
- chore: update issue templates ([#40](https://github.com/googleapis/nodejs-projectify/pull/40))
- chore: remove old issue template ([#38](https://github.com/googleapis/nodejs-projectify/pull/38))
- build: run tests on node11 ([#37](https://github.com/googleapis/nodejs-projectify/pull/37))
- chores(build): run codecov on continuous builds ([#34](https://github.com/googleapis/nodejs-projectify/pull/34))
- chores(build): do not collect sponge.xml from windows builds ([#35](https://github.com/googleapis/nodejs-projectify/pull/35))
- chore: update new issue template ([#33](https://github.com/googleapis/nodejs-projectify/pull/33))
- build: fix codecov uploading on Kokoro ([#30](https://github.com/googleapis/nodejs-projectify/pull/30))
- Update kokoro config ([#28](https://github.com/googleapis/nodejs-projectify/pull/28))
- Update CI config ([#26](https://github.com/googleapis/nodejs-projectify/pull/26))
- Don't publish sourcemaps ([#24](https://github.com/googleapis/nodejs-projectify/pull/24))
- build: prevent system/sample-test from leaking credentials
- Update kokoro config ([#22](https://github.com/googleapis/nodejs-projectify/pull/22))
- test: remove appveyor config ([#21](https://github.com/googleapis/nodejs-projectify/pull/21))
- Update CI config ([#20](https://github.com/googleapis/nodejs-projectify/pull/20))
- Enable prefer-const in the eslint config ([#19](https://github.com/googleapis/nodejs-projectify/pull/19))
- Enable no-var in eslint ([#18](https://github.com/googleapis/nodejs-projectify/pull/18))
- Update CI config ([#17](https://github.com/googleapis/nodejs-projectify/pull/17))
- Add synth and update CI config ([#15](https://github.com/googleapis/nodejs-projectify/pull/15))
- chore: ignore package-lock.json ([#12](https://github.com/googleapis/nodejs-projectify/pull/12))
- chore: update renovate config ([#10](https://github.com/googleapis/nodejs-projectify/pull/10))
- remove that whitespace ([#9](https://github.com/googleapis/nodejs-projectify/pull/9))
- chore: assert.deelEqual => assert.deepStrictEqual ([#6](https://github.com/googleapis/nodejs-projectify/pull/6))
- chore: move mocha options to mocha.opts ([#5](https://github.com/googleapis/nodejs-projectify/pull/5))

